################################################################################
#
# \attention  This program is provided as is. You can redistribute it and/or
# modify it. Fujitsu Semiconductor Limited accepts no responsibility or
# liability for any errors or omissions.
#
# Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
#

################################################################################
# defines
################################################################################

#!/bin/sh

  LN=/bin/ln
  MKDIR=/bin/mkdir
  PWD=/bin/pwd

  TOPDIR=.
  CURDIR=`${PWD}`

  CNFGHDR_SRC_PATH=${CURDIR}/wfe/config
  BOARDHDR_SRC_PATH=${CURDIR}/wfe/config/boards

  FAPI_INC_PATH=${CURDIR}/../../../../FAPI_V01L00R00/fapi_driver/fapicore/include
  FAPI_ENV_PATH=${CURDIR}/../../../../FAPI_V01L00R00/fapi_driver/fapicore/env

  FAPI_CORE_PATH=${CURDIR}/../../../../FAPI_V01L00R00/fapi_driver/fapicore/core_drv

################################################################################
# set link symbols
################################################################################

# include file (fapi)
  ${LN} -s ${FAPI_INC_PATH} ${TOPDIR}/fapicore
  ${LN} -s ${FAPI_ENV_PATH} ${TOPDIR}/fapicore

# include file (wfe)
  ${LN} -s ./fapex_linux_stdhdr.h ${TOPDIR}/wfe/include/fapi_linux_stdhdr.h
  ${LN} -s ${BOARDHDR_SRC_PATH}/mb86h61_dk01/mb86h61_dk01.h   ${TOPDIR}/wfe/config/boards/
  ${LN} -s ${BOARDHDR_SRC_PATH}/mb86h61_pdkv1/mb86h61_pdkv1.h ${TOPDIR}/wfe/config/boards/
  ${LN} -s ${CNFGHDR_SRC_PATH}/sys_config.h                ${TOPDIR}/wfe/include/fapex/.
  ${LN} -s ${CNFGHDR_SRC_PATH}/sys_config_mb86h61_devkit.h ${TOPDIR}/wfe/include/fapex/.

# FAPI driver (fapi_core)
  ${LN} -s ${FAPI_CORE_PATH} ${TOPDIR}/fapicore

