/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 CFDL module
 system abstraction
*/

#include "fapex.h"
#include "fapex_cfdlsaf.h"
#include "fapex_cfdl_priv.h"

#define __FAPEX_CFDL_SAF_C__

/**************************************************************/
/*   Global Data                                              */
/**************************************************************/
/* FAPEX System Abstraction Functions (SAF) */
/* These functions extend the FAPI system abstraction */
FAPEXCFDLSAF_ServicesT FAPEXCFDLSAF_Services = {
    NULL,   // getid
    NULL,   // clear_memory
    NULL,   // event_create
    NULL,   // event_delete
    NULL,   // event_wait
    NULL,   // event_set
    NULL,   // event_poll
    NULL,   // copy_to_user
    NULL,   // copy_to_drv
    NULL,   // spinlock_create
    NULL,   // spinlock_delete
    NULL,   // spinlock
    NULL    // spinunlock
};

/* register SAF */
void FAPEXCFDLSAF_SetServices(FAPEXCFDLSAF_ServicesT* pSys)
{
    if( pSys != NULL){
        memcpy( &FAPEXCFDLSAF_Services, pSys, sizeof(FAPEXCFDLSAF_ServicesT));
    }
}

#ifdef __LINUX__

/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(FAPEXCFDLSAF_Services);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
