/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI BOARD configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/board_ifc.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_board_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_BOARD_FuncStrT board_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_BOARD_Init(void)
{
    int32_t ret = 0;

    board_funcStr.SetBoardInitDetectHook                  = FAPI_BOARD_SetBoardInitDetectHook;
    board_funcStr.SetControlTestLedKeyHook                = FAPI_BOARD_SetControlTestLedKeyHook;
    board_funcStr.SetControlFeResetHook                   = FAPI_BOARD_SetControlFeResetHook;
    board_funcStr.SetControlFeDetectHook                  = FAPI_BOARD_SetControlFeDetectHook;
    board_funcStr.SetControlHdResetHook                   = FAPI_BOARD_SetControlHdResetHook;
    board_funcStr.SetControlScartHook                     = FAPI_BOARD_SetControlScartHook;
    board_funcStr.SetControlTsPathHook                    = FAPI_BOARD_SetControlTsPathHook;
    board_funcStr.SetDiagnostic_TsPath                    = FAPI_BOARD_SetDiagnostic_TsPath;
    board_funcStr.SetDiagnostic_EnableBits_TsPath         = FAPI_BOARD_SetDiagnostic_EnableBits_TsPath;
    board_funcStr.SetControlHdmiPathHook                  = FAPI_BOARD_SetControlHdmiPathHook;
    board_funcStr.SetDiagnostic_HdmiPath                  = FAPI_BOARD_SetDiagnostic_HdmiPath;
    board_funcStr.SetDiagnostic_EnableBits_HdmiPath       = FAPI_BOARD_SetDiagnostic_EnableBits_HdmiPath;
    board_funcStr.SetControlUsbPhy                        = FAPI_BOARD_SetControlUsbPhy;
    board_funcStr.SetControlPowerMode                     = FAPI_BOARD_SetControlPowerMode;
    board_funcStr.SetBoardInfo                            = FAPI_BOARD_SetBoardInfo;
    board_funcStr.GetBoardInfo                            = FAPI_BOARD_GetBoardInfo;
    board_funcStr.SetCiInterface                          = FAPI_BOARD_SetCiInterface;
    board_funcStr.GetCiInterface                          = FAPI_BOARD_GetCiInterface;
    board_funcStr.SetDiagnostic_CiInterface               = FAPI_BOARD_SetDiagnostic_CiInterface;
    board_funcStr.SetDiagnostic_EnableBits_CiInterface    = FAPI_BOARD_SetDiagnostic_EnableBits_CiInterface;
    board_funcStr.SetDiagnostic_GeneralPurpose            = FAPI_BOARD_SetDiagnostic_GeneralPurpose;
    board_funcStr.SetDiagnostic_EnableBits_GeneralPurpose = FAPI_BOARD_SetDiagnostic_EnableBits_GeneralPurpose;
    board_funcStr.SetExtendedFrontendInfo                 = FAPI_BOARD_SetExtendedFrontendInfo;
    board_funcStr.GetExtendedFrontendInfo                 = FAPI_BOARD_GetExtendedFrontendInfo;
    board_funcStr.SetMemoryMapInfo                        = FAPI_BOARD_SetMemoryMapInfo;
    board_funcStr.GetMemoryMapInfo                        = FAPI_BOARD_GetMemoryMapInfo;
    board_funcStr.SetExtI2cCtrlDrvData                    = FAPI_BOARD_SetExtI2cCtrlDrvData;
    board_funcStr.GetExtI2cCtrlDrvData                    = FAPI_BOARD_GetExtI2cCtrlDrvData;

    /* support for FAPI_BOARD_Services */
    board_funcStr.BoardServices                           = FAPI_BOARD_Services;

    /* initialize function of FAPI CDL (board) */
    return ret;
}
/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_BOARD_cleanup(void)
{
    /* unregister interrupt */
    //

    //
}
/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
/* nothing */

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(board_funcStr);
EXPORT_SYMBOL(FAPEXCFG_BOARD_cleanup);
EXPORT_SYMBOL(FAPEXCFG_BOARD_Init);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
