/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI DESC configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_desc.h"
#include "fapi/drv_intr.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_desc_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_DESC_FuncStrT desc_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_DESC_Init(void)
{
    int32_t ret = 0;

    desc_funcStr.Init             = FAPI_DESC_Init;
    desc_funcStr.Exit             = FAPI_DESC_Exit;
    desc_funcStr.Open             = FAPI_DESC_Open;
    desc_funcStr.Close            = FAPI_DESC_Close;
    desc_funcStr.SetKeys          = FAPI_DESC_SetKeys;
    desc_funcStr.Start            = FAPI_DESC_Start;
    desc_funcStr.Stop             = FAPI_DESC_Stop;
    desc_funcStr.SetSystemKey     = FAPI_DESC_SetSystemKey;
    desc_funcStr.SetInitialVector = FAPI_DESC_SetInitialVector;
 //   desc_funcStr.SetKeyladderIndex   = FAPI_DESC_SetKeyladderIndex;
 //   desc_funcStr.RunKeyladder        = FAPI_DESC_RunKeyladder;
 //   desc_funcStr.SetKeyladderHostKey = FAPI_DESC_SetKeyladderHostKey;

    /* initialize function of FAPI CDL (desc) */
    ret = desc_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_DESC_Cleanup(void)
{
    /* unregister interrupt */
//  FAPEXCFG_INTR_UnregisterISR(FAPI_INTR_UNDEFINED);

    desc_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(desc_funcStr);

EXPORT_SYMBOL(FAPEXCFG_DESC_Init);
EXPORT_SYMBOL(FAPEXCFG_DESC_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
