/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 *  Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI FLASH configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_flash.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_flash_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_FLASH_FuncStrT flash_funcStr;

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_FLASH_Init(void)
{
    int32_t ret;

    flash_funcStr.SetEnable           = FAPI_FLASH_SetEnable;
    flash_funcStr.SetUpiIndex         = FAPI_FLASH_SetUpiIndex;
    flash_funcStr.Init                = FAPI_FLASH_Init;
    flash_funcStr.Exit                = FAPI_FLASH_Exit;
    flash_funcStr.Open                = FAPI_FLASH_Open;
    flash_funcStr.Close               = FAPI_FLASH_Close;
    flash_funcStr.EraseChip           = FAPI_FLASH_EraseChip;
    flash_funcStr.EraseSector         = FAPI_FLASH_EraseSector;
    flash_funcStr.ReadBytes           = FAPI_FLASH_ReadBytes;
    flash_funcStr.WriteBytes          = FAPI_FLASH_WriteBytes;
    flash_funcStr.Flush               = FAPI_FLASH_Flush;
    flash_funcStr.GetDeviceSize       = FAPI_FLASH_GetDeviceSize;
    flash_funcStr.GetDeviceId         = FAPI_FLASH_GetDeviceId;
    flash_funcStr.GetManufacturerId   = FAPI_FLASH_GetManufacturerId;
    flash_funcStr.GetDeviceName       = FAPI_FLASH_GetDeviceName;
    flash_funcStr.GetManufacturerName = FAPI_FLASH_GetManufacturerName;
    flash_funcStr.GetSectorCount      = FAPI_FLASH_GetSectorCount;
    flash_funcStr.GetSectorIndex      = FAPI_FLASH_GetSectorIndex;
    flash_funcStr.GetSectorStart      = FAPI_FLASH_GetSectorStart;
    flash_funcStr.GetSectorBytes      = FAPI_FLASH_GetSectorBytes;
    flash_funcStr.IsSectorEmpty       = FAPI_FLASH_IsSectorEmpty;
    flash_funcStr.IsChipEmpty         = FAPI_FLASH_IsChipEmpty;
    flash_funcStr.IsSectorProtected   = FAPI_FLASH_IsSectorProtected;
    flash_funcStr.ProtectSector       = FAPI_FLASH_ProtectSector;

    /* setup board parameters */
    FAPI_SYS_FLASH_SET_BOARD_PARAMS

    /* initialize function of FAPI CDL (flash) */
    ret = flash_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_FLASH_Cleanup(void)
{
    flash_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(flash_funcStr);

EXPORT_SYMBOL(FAPEXCFG_FLASH_Init);
EXPORT_SYMBOL(FAPEXCFG_FLASH_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
