/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 *  Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI FPC configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_fpc.h"
#include "fapi/reg_fpc.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_fpc_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_FPC_FuncStrT fpc_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_FPC_Init(void)
{
    int32_t ret = 0;

    fpc_funcStr.Init                  = FAPI_FPC_Init;
    fpc_funcStr.Exit                  = FAPI_FPC_Exit;
    fpc_funcStr.Bsr                   = FAPI_FPC_Bsr;
    fpc_funcStr.Open                  = FAPI_FPC_Open;
    fpc_funcStr.Close                 = FAPI_FPC_Close;
    fpc_funcStr.SetMode               = FAPI_FPC_SetMode;
    fpc_funcStr.SetSelectBitInversion = FAPI_FPC_SetSelectBitInversion;
    fpc_funcStr.SetDividerClock       = FAPI_FPC_SetDividerClock;
    fpc_funcStr.SetDividerSeg         = FAPI_FPC_SetDividerSeg;
    fpc_funcStr.SetInitialBrightness  = FAPI_FPC_SetInitialBrightness;
    fpc_funcStr.SetLeadingZeros       = FAPI_FPC_SetLeadingZeros;
    fpc_funcStr.SetButtonFunction     = FAPI_FPC_SetButtonFunction;
    fpc_funcStr.SetBrightness         = FAPI_FPC_SetBrightness;
    fpc_funcStr.IncreaseBrightness    = FAPI_FPC_IncreaseBrightness;
    fpc_funcStr.DecreaseBrightness    = FAPI_FPC_DecreaseBrightness;
    fpc_funcStr.SetDisplayWord        = FAPI_FPC_SetDisplayWord;
    fpc_funcStr.SetDigitAt            = FAPI_FPC_SetDigitAt;
    fpc_funcStr.IncrementCipherAt     = FAPI_FPC_IncrementCipherAt;
    fpc_funcStr.DecrementCipherAt     = FAPI_FPC_DecrementCipherAt;
    fpc_funcStr.GetCipherAt           = FAPI_FPC_GetCipherAt;
    fpc_funcStr.SetCipherAt           = FAPI_FPC_SetCipherAt;
    fpc_funcStr.IsDotActiveAt         = FAPI_FPC_IsDotActiveAt;
    fpc_funcStr.ToggleDotAt           = FAPI_FPC_ToggleDotAt;
    fpc_funcStr.GetIntegerValue       = FAPI_FPC_GetIntegerValue;
    fpc_funcStr.SetIntegerValue       = FAPI_FPC_SetIntegerValue;
    fpc_funcStr.IncrementIntegerValue = FAPI_FPC_IncrementIntegerValue;
    fpc_funcStr.DecrementIntegerValue = FAPI_FPC_DecrementIntegerValue;
    fpc_funcStr.SetScrollText         = FAPI_FPC_SetScrollText;

    /* initialize function of FAPI RAL */
    /*
    (FPC)
     FREG_FPC <----
    (IR)
     FREG_FPC <----
     FREG_IR
    */
    if(FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_FPC] == 0){
        FREG_FPC_Init();
        FAPEXCFG_RAL_initialized_flag[FAPEX_RAL_MODULEID_FPC] = 1;
    }

    /* initialize function of FAPI CDL (fpc) */
    ret = fpc_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_FPC_Cleanup(void)
{
    fpc_funcStr.Exit();
}


#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(fpc_funcStr);

EXPORT_SYMBOL(FAPEXCFG_FPC_Init);
EXPORT_SYMBOL(FAPEXCFG_FPC_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
