/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI GPREG configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_gpreg.h"
#include "fapi/drv_intr.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_gpreg_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_GPREG_FuncStrT gpreg_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_GPREG_Init(void)
{
    int32_t ret = 0;

    gpreg_funcStr.Init        = FAPI_GPREG_Init;
    gpreg_funcStr.Exit        = FAPI_GPREG_Exit;
    gpreg_funcStr.Open        = FAPI_GPREG_Open;
    gpreg_funcStr.Close       = FAPI_GPREG_Close;
    gpreg_funcStr.Read        = FAPI_GPREG_Read;
    gpreg_funcStr.Write       = FAPI_GPREG_Write;
    gpreg_funcStr.LockMutex   = FAPI_GPREG_LockMutex;
    gpreg_funcStr.UnlockMutex = FAPI_GPREG_UnlockMutex;

    /* initialize function of FAPI CDL (gpreg) */
    ret = gpreg_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_GPREG_Cleanup(void)
{
    /* unregister interrupt */
//  FAPEXCFG_INTR_UnregisterISR(FAPI_INTR_UNDEFINED);

    gpreg_funcStr.Exit();
}


#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(gpreg_funcStr);

EXPORT_SYMBOL(FAPEXCFG_GPREG_Init);
EXPORT_SYMBOL(FAPEXCFG_GPREG_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
