/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI HDMI configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_hdmi.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_hdmi_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_HDMI_FuncStrT hdmi_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_HDMI_Init(void)
{
    int32_t ret;

    hdmi_funcStr.Init                     = FAPI_HDMI_Init;
    hdmi_funcStr.Exit                     = FAPI_HDMI_Exit;
    hdmi_funcStr.Open                     = FAPI_HDMI_Open;
    hdmi_funcStr.Close                    = FAPI_HDMI_Close;
    hdmi_funcStr.GetPhysicalAddressInEDID = FAPI_HDMI_GetPhysicalAddressInEDID;
    hdmi_funcStr.ReadEDID                 = FAPI_HDMI_ReadEDID;
    hdmi_funcStr.LinkHDCP                 = FAPI_HDMI_LinkHDCP;
    hdmi_funcStr.VIDEO_Start              = FAPI_HDMI_VIDEO_Start;
    hdmi_funcStr.AUDIO_Start              = FAPI_HDMI_AUDIO_Start;
    hdmi_funcStr.VIDEO_Stop               = FAPI_HDMI_VIDEO_Stop;
    hdmi_funcStr.AUDIO_Stop               = FAPI_HDMI_AUDIO_Stop;
    hdmi_funcStr.SetVideoParameters       = FAPI_HDMI_SetVideoParameters;
    hdmi_funcStr.GetVideoParameters       = FAPI_HDMI_GetVideoParameters;
    hdmi_funcStr.SetAudioParameters       = FAPI_HDMI_SetAudioParameters;
    hdmi_funcStr.GetAudioParameters       = FAPI_HDMI_GetAudioParameters;
    hdmi_funcStr.SetAudioSampleFrequency  = FAPI_HDMI_SetAudioSampleFrequency;
    hdmi_funcStr.CheckHPD                 = FAPI_HDMI_CheckHPD;
    hdmi_funcStr.CheckHDCPState           = FAPI_HDMI_CheckHDCPState;
    hdmi_funcStr.GetEDID_Info             = FAPI_HDMI_GetEDID_Info;
    hdmi_funcStr.GetEDID_Data             = FAPI_HDMI_GetEDID_Data;
    hdmi_funcStr.SetRevocationList        = FAPI_HDMI_SetRevocationList;
    hdmi_funcStr.UpdateAviInfoFrame       = FAPI_HDMI_UpdateAviInfoFrame;
    hdmi_funcStr.DynamicChangeHDCP        = FAPI_HDMI_DynamicChangeHDCP;

    /* initialize function of FAPI CDL (hdmi) */
    ret = hdmi_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_HDMI_Cleanup(void)
{
    hdmi_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(hdmi_funcStr);

EXPORT_SYMBOL(FAPEXCFG_HDMI_Init);
EXPORT_SYMBOL(FAPEXCFG_HDMI_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
