/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI SYNC configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_sync.h"
#include "fapi/drv_intr.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_sync_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_SYNC_FuncStrT sync_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_SYNC_Init(void)
{
    int32_t ret = 0;

    sync_funcStr.Init                = FAPI_SYNC_Init;
    sync_funcStr.Exit                = FAPI_SYNC_Exit;
    sync_funcStr.Open                = FAPI_SYNC_Open;
    sync_funcStr.Close               = FAPI_SYNC_Close;
    sync_funcStr.DpllFaster          = FAPI_SYNC_DpllFaster;
    sync_funcStr.DpllSlower          = FAPI_SYNC_DpllSlower;
    sync_funcStr.DpllRegulation      = FAPI_SYNC_DpllRegulation;
    sync_funcStr.GetDecoderOffset    = FAPI_SYNC_GetDecoderOffset;
    sync_funcStr.GetDpllControlFlags = FAPI_SYNC_GetDpllControlFlags;
    sync_funcStr.GetEnvironment      = FAPI_SYNC_GetEnvironment;
    sync_funcStr.GetPcrStcDifference = FAPI_SYNC_GetPcrStcDifference;
    sync_funcStr.GetPcr              = FAPI_SYNC_GetPcr;
    sync_funcStr.GetPcrPid           = FAPI_SYNC_GetPcrPid;
    sync_funcStr.GetStatus           = FAPI_SYNC_GetStatus;
    sync_funcStr.GetStc              = FAPI_SYNC_GetStc;
    sync_funcStr.GetStcLower         = FAPI_SYNC_GetStcLower;
    sync_funcStr.GetStcRegulation    = FAPI_SYNC_GetStcRegulation;
    sync_funcStr.PcrNotifier         = FAPI_SYNC_PcrNotifier;
    sync_funcStr.ResetRegulation     = FAPI_SYNC_ResetRegulation;
    sync_funcStr.ResetStatus         = FAPI_SYNC_ResetStatus;
    sync_funcStr.SetDecoderOffset    = FAPI_SYNC_SetDecoderOffset;
    sync_funcStr.SetDpllEnable       = FAPI_SYNC_SetDpllEnable;
    sync_funcStr.SetEnvironment      = FAPI_SYNC_SetEnvironment;
    sync_funcStr.SetPcrPid           = FAPI_SYNC_SetPcrPid;
    sync_funcStr.SetPllFreq          = FAPI_SYNC_SetPllFreq;
    sync_funcStr.SetStatus           = FAPI_SYNC_SetStatus;
    sync_funcStr.SetStcLower         = FAPI_SYNC_SetStcLower;
    sync_funcStr.SetStcRegulation    = FAPI_SYNC_SetStcRegulation;

    /* initialize function of FAPI CDL (sync) */
    ret = sync_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_SYNC_Cleanup(void)
{
    /* unregister interrupt */
//  FAPEXCFG_INTR_UnregisterISR(FAPI_INTR_UNDEFINED);

    sync_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(sync_funcStr);

EXPORT_SYMBOL(FAPEXCFG_SYNC_Init);
EXPORT_SYMBOL(FAPEXCFG_SYNC_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
