/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FAPI INTR configuration code.
*/

#include "fapex_stdhdr.h"
#include "fapi/drv_ttx.h"
#include "fapex/sys_config.h"
#include "fapex_config_cmn.h"
#include "fapex_ttx_func.h"

/*--------------------------------------------------------*/
/* Global Data                                            */
/*--------------------------------------------------------*/
FAPEX_TTX_FuncStrT ttx_funcStr;

/*--------------------------------------------------------*/
/* ISR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* BSR.                                                   */
/*--------------------------------------------------------*/
/* nothing */

/*--------------------------------------------------------*/
/* INIT.                                                  */
/*--------------------------------------------------------*/
int32_t FAPEXCFG_TTX_Init(void)
{
    int32_t ret;

    ttx_funcStr.Init                          = FAPI_TTX_Init;
    ttx_funcStr.Exit                          = FAPI_TTX_Exit;
    ttx_funcStr.Open                          = FAPI_TTX_Open;
    ttx_funcStr.Close                         = FAPI_TTX_Close;
    ttx_funcStr.Disable                       = FAPI_TTX_Disable;
    ttx_funcStr.Enable                        = FAPI_TTX_Enable;
    ttx_funcStr.EnableReinsertion             = FAPI_TTX_EnableReinsertion;
    ttx_funcStr.SetChannelPid                 = FAPI_TTX_SetChannelPid;
    ttx_funcStr.GetChannelPid                 = FAPI_TTX_GetChannelPid;
    ttx_funcStr.GetBufferWritePointerPosition = FAPI_TTX_GetBufferWritePointerPosition;
    ttx_funcStr.GetTtxRows                    = FAPI_TTX_GetTtxRows;
    ttx_funcStr.Start                         = FAPI_TTX_Start;
    ttx_funcStr.Stop                          = FAPI_TTX_Stop;

    /* initialize function of FAPI CDL (ttx) */
    ret = ttx_funcStr.Init();

    return ret;
}

/*--------------------------------------------------------*/
/* CLEANUP.                                               */
/*--------------------------------------------------------*/
void FAPEXCFG_TTX_Cleanup(void)
{
    ttx_funcStr.Exit();
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
EXPORT_SYMBOL(ttx_funcStr);

EXPORT_SYMBOL(FAPEXCFG_TTX_Init);
EXPORT_SYMBOL(FAPEXCFG_TTX_Cleanup);
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
