/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FDL module skel_drv
*/

#include "fapex.h"
#include "fapex/abst_libfpc.h"
#include "fapex/sys_config.h"
#include "fapex_fdlfpc_priv.h"
#include "fapex_config_cmn.h"

/* for fpc_funcStr */
#include "fapex_func_ext.h"

/*
*******************************************************************************
*******************************************************************************
** Global Data
*******************************************************************************
*******************************************************************************/

/*
*******************************************************************************
*******************************************************************************
** Local Data
*******************************************************************************
*******************************************************************************/
#ifndef ALLOCATE_DYNAMIC_MEMORY
static FAPEXFDL_FPC_StrT  FAPIGLD_FDLFPCCtx[FAPEXDEV_FPC_DESCRIPTOR_NUM];
#endif /* !ALLOCATE_DYNAMIC_MEMORY */

#if 0 /* not supported */
/*!
*******************************************************************************
**
** \brief  Read method of this id's FDL.
**         This function is called with the systemcall "read".
**
** If copy data to the argument's buffer, use FAPI_SYS_copyFromUser().
**
** \param  file    The pointer to the struct file.
** \param  buf     The pointer to the base address of the buffer.
** \param  size    The buffer size.
** \param  offset  The offset (now, not supported).
**
******************************************************************************/
FAPEXFDLREADRET_T FAPEXFDLFPC_read(FAPEXFDLREADARG1_T file, FAPEXFDLREADARG2_T buf,
                                   FAPEXFDLREADARG3_T size, FAPEXFDLREADARG4_T offset)
{
    FAPEXDebugPrint(3, "[FAPEXFDLFPC_read] size:%d\n",size);

    return size;
}
#endif

#if 0 /* not supported */
/*!
*******************************************************************************
**
** \brief  Write method of this id's FDL.
**         This function is called with the systemcall "write".
**
** If copy data from the argument's buffer, use FAPI_SYS_copyToUser().
**
** \param  file    The pointer to the struct file.
** \param  buf     The pointer to the base address of the buffer.
** \param  size    The buffer size.
** \param  offset  The offset (now, not supported).
**
******************************************************************************/
FAPEXFDLWRTRET_T FAPEXFDLFPC_write(FAPEXFDLWRTARG1_T file, FAPEXFDLWRTARG2_T buf,
                                   FAPEXFDLWRTARG3_T size, FAPEXFDLWRTARG4_T offset)
{
    FAPEXDebugPrint(3, "[FAPEXFDLFPC_write] size:%d\n",size);

    return size;
}
#endif

/*!
*******************************************************************************
**
** \brief  Button Event Notifer
**
******************************************************************************/
static void fdlfpc_button1Notifier( void *optDataPtr )
{
    FAPEXFDL_FPC_StrT *pfunc = (FAPEXFDL_FPC_StrT *)optDataPtr;

    if(pfunc->btn_enable_flag & FAPEX_FPC_EVENT_BUTTON1) {
        /* set event */
        FAPEXCFDLSAF_SET_EVENT( &pfunc->btn_event,
                                FAPEX_FPC_EVENT_BUTTON1,
                                FAPEXCFDLSAF_WAITEVENT_OR );
    }
}
static void fdlfpc_button2Notifier( void *optDataPtr )
{
    FAPEXFDL_FPC_StrT *pfunc = (FAPEXFDL_FPC_StrT *)optDataPtr;

    if(pfunc->btn_enable_flag & FAPEX_FPC_EVENT_BUTTON1) {
        /* set event */
        FAPEXCFDLSAF_SET_EVENT( &pfunc->btn_event,
                                FAPEX_FPC_EVENT_BUTTON2,
                                FAPEXCFDLSAF_WAITEVENT_OR );
    }
}
static void fdlfpc_button3Notifier( void *optDataPtr )
{
    FAPEXFDL_FPC_StrT *pfunc = (FAPEXFDL_FPC_StrT *)optDataPtr;

    if(pfunc->btn_enable_flag & FAPEX_FPC_EVENT_BUTTON1) {
        /* set event */
        FAPEXCFDLSAF_SET_EVENT( &pfunc->btn_event,
                                FAPEX_FPC_EVENT_BUTTON3,
                                FAPEXCFDLSAF_WAITEVENT_OR );
    }
}
static void fdlfpc_button4Notifier( void *optDataPtr )
{
    FAPEXFDL_FPC_StrT *pfunc = (FAPEXFDL_FPC_StrT *)optDataPtr;

    if(pfunc->btn_enable_flag & FAPEX_FPC_EVENT_BUTTON1) {
        /* set event */
        FAPEXCFDLSAF_SET_EVENT( &pfunc->btn_event,
                                FAPEX_FPC_EVENT_BUTTON4,
                                FAPEXCFDLSAF_WAITEVENT_OR );
    }
}
static void fdlfpc_button5Notifier( void *optDataPtr )
{
    FAPEXFDL_FPC_StrT *pfunc = (FAPEXFDL_FPC_StrT *)optDataPtr;

    if(pfunc->btn_enable_flag & FAPEX_FPC_EVENT_BUTTON1) {
        /* set event */
        FAPEXCFDLSAF_SET_EVENT( &pfunc->btn_event,
                                FAPEX_FPC_EVENT_BUTTON5,
                                FAPEXCFDLSAF_WAITEVENT_OR );
    }
}
static void fdlfpc_button6Notifier( void *optDataPtr )
{
    FAPEXFDL_FPC_StrT *pfunc = (FAPEXFDL_FPC_StrT *)optDataPtr;

    if(pfunc->btn_enable_flag & FAPEX_FPC_EVENT_BUTTON1) {
        /* set event */
        FAPEXCFDLSAF_SET_EVENT( &pfunc->btn_event,
                                FAPEX_FPC_EVENT_BUTTON6,
                                FAPEXCFDLSAF_WAITEVENT_OR );
    }
}
static void fdlfpc_button7Notifier( void *optDataPtr )
{
    FAPEXFDL_FPC_StrT *pfunc = (FAPEXFDL_FPC_StrT *)optDataPtr;

    if(pfunc->btn_enable_flag & FAPEX_FPC_EVENT_BUTTON1) {
        /* set event */
        FAPEXCFDLSAF_SET_EVENT( &pfunc->btn_event,
                                FAPEX_FPC_EVENT_BUTTON7,
                                FAPEXCFDLSAF_WAITEVENT_OR );
    }
}
static void fdlfpc_button8Notifier( void *optDataPtr )
{
    FAPEXFDL_FPC_StrT *pfunc = (FAPEXFDL_FPC_StrT *)optDataPtr;

    if(pfunc->btn_enable_flag & FAPEX_FPC_EVENT_BUTTON1) {
        /* set event */
        FAPEXCFDLSAF_SET_EVENT( &pfunc->btn_event,
                                FAPEX_FPC_EVENT_BUTTON8,
                                FAPEXCFDLSAF_WAITEVENT_OR );
    }
}

/*!
*******************************************************************************
**
** \brief  General control of this id's FDL.
**         This function is called with systemcall "ioctl".
**
** \param  inode   The pointer to the struct inode.
** \param  file    The pointer to the struct file.
** \param  cmd     The ioctl command. This is set by user application. On Linux,
**                 the kernel copy this data to the kernel space. On RTOS, this
**                 memory area is shared with the user.
**                 memory of the user
** \param  arg     The argument of the ioctl command. This is set by user 
**                 application. On Linux, the kernel copy this data to the kernel
**                 space. On RTOS, thismemory area is shared with the user.
**
******************************************************************************/
FAPEXFDLIOCRET_T FAPEXFDLFPC_ioctl(FAPEXFDLIOCARG1_T inode, FAPEXFDLIOCARG2_T file,
                                   FAPEXFDLIOCARG3_T cmd, FAPEXFDLIOCARG4_T arg)
{
    FAPEXFDL_FPC_StrT *pfunc;
    int32_t  ret = FAPEX_FPC_ERR_BAD_PARAMETER;

    FAPEXDebugPrint(3, "[FAPEXFDLFPC_ioctl] cmd:%08x\n",cmd);

    /* Get the context base of this id's FDL. */
    pfunc = (FAPEXFDL_FPC_StrT*)(file->private_data);

    switch(cmd) {
        /* actual code which is depend on function is implimented here. */
#ifdef FAPI_FPC_CONNECT
        case FAPEX_IOCCOM_OPEN:
            if(pfunc->pFAPICtxHdl == NULL) {
                FAPI_FPC_OpenParamsT params;

                /* open sequence */
                params.version = FAPI_FPC_VERSION;
                pfunc->pFAPICtxHdl = fpc_funcStr.Open(&params, &ret);
                FAPEXDebugPrint(3, "[fdlfpc_Open] FAPI context:0x%08x\n",
                                   (uint32_t)pfunc->pFAPICtxHdl);
                if(pfunc->pFAPICtxHdl == NULL) {
                    FAPEXDebugPrint(2, "[FAPEXFDLFPC_ioctl] FAPI_FPC_Open error:%d\n", ret);
                }
                else {
                    FAPEXCFDLSAF_EventStrT  *dt_event_ptr;
                    int32_t  result = 0;

                    dt_event_ptr = &pfunc->btn_event;
                    if(dt_event_ptr->initialized == 0) {
                        FAPEXCFDLSAF_CREATE_EVENT(dt_event_ptr);
                    }

                    /* call FAPI (setup button function) */
                    ret = fpc_funcStr.SetButtonFunction(
                                pfunc->pFAPICtxHdl, 1, fdlfpc_button1Notifier, pfunc);
                    if(ret == FAPI_OK) {
                        pfunc->btn_enable_flag |= FAPEX_FPC_EVENT_BUTTON1;
                    }

                    result = fpc_funcStr.SetButtonFunction(
                                pfunc->pFAPICtxHdl, 2, fdlfpc_button2Notifier, pfunc);
                    if(result == FAPI_OK) {
                        pfunc->btn_enable_flag |= FAPEX_FPC_EVENT_BUTTON2;
                    }
                    else if(ret == 0) {
                        ret = result;
                    }

                    result = fpc_funcStr.SetButtonFunction(
                                pfunc->pFAPICtxHdl, 3, fdlfpc_button3Notifier, pfunc);
                    if(result == FAPI_OK) {
                        pfunc->btn_enable_flag |= FAPEX_FPC_EVENT_BUTTON3;
                    }
                    else if(ret == 0) {
                        ret = result;
                    }

                    result = fpc_funcStr.SetButtonFunction(
                                pfunc->pFAPICtxHdl, 4, fdlfpc_button4Notifier, pfunc);
                    if(result == FAPI_OK) {
                        pfunc->btn_enable_flag |= FAPEX_FPC_EVENT_BUTTON4;
                    }
                    else if(ret == 0) {
                        ret = result;
                    }

                    result = fpc_funcStr.SetButtonFunction(
                                pfunc->pFAPICtxHdl, 5, fdlfpc_button5Notifier, pfunc);
                    if(result == FAPI_OK) {
                        pfunc->btn_enable_flag |= FAPEX_FPC_EVENT_BUTTON5;
                    }
                    else if(ret == 0) {
                        ret = result;
                    }

                    result = fpc_funcStr.SetButtonFunction(
                                pfunc->pFAPICtxHdl, 6, fdlfpc_button6Notifier, pfunc);
                    if(result == FAPI_OK) {
                        pfunc->btn_enable_flag |= FAPEX_FPC_EVENT_BUTTON6;
                    }
                    else if(ret == 0) {
                        ret = result;
                    }

                    result = fpc_funcStr.SetButtonFunction(
                                pfunc->pFAPICtxHdl, 7, fdlfpc_button7Notifier, pfunc);
                    if(result == FAPI_OK) {
                        pfunc->btn_enable_flag |= FAPEX_FPC_EVENT_BUTTON7;
                    }
                    else if(ret == 0) {
                        ret = result;
                    }

                    result = fpc_funcStr.SetButtonFunction(
                                pfunc->pFAPICtxHdl, 8, fdlfpc_button8Notifier, pfunc);
                    if(result == FAPI_OK) {
                        pfunc->btn_enable_flag |= FAPEX_FPC_EVENT_BUTTON8;
                    }
                    else if(ret == 0) {
                        ret = result;
                    }

                    if(pfunc->btn_enable_flag != 0) {
                        pfunc->btn_enable_flag |= FAPEX_FPC_EVENT_END;
                    }
                    if(ret != 0) {
                        FAPEXDebugPrint(2, "[FAPEXFDLFPC_ioctl] "
                                           "FAPI_FPC_SetButtonFunction error:%d\n", ret);
                    }
                }
            }
            else {
                ret = 0;
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_BRIGHTNESS:
            {
                uint32_t brightness = (uint32_t)arg;

                /* call FAPI (set brightness value) */
                ret = fpc_funcStr.SetBrightness(pfunc->pFAPICtxHdl, brightness);
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_CAHNGE_BRIGHTNESS:
            {
                int32_t steps = (int32_t)arg;

                /* call FAPI (change brightness value) */
                if(steps >= 0) {
                    ret = fpc_funcStr.IncreaseBrightness(pfunc->pFAPICtxHdl, steps);
                }
                else {
                    ret = fpc_funcStr.DecreaseBrightness(pfunc->pFAPICtxHdl, -steps);
                }
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_DISPLAY_SEGMENT:
            if(arg != (FAPEXFDLIOCARG4_T)NULL) {
                FAPEX_FPC_DispSegParamStrT  params, *pArg;
                uint32_t  bitmsk, i;

                pArg = (FAPEX_FPC_DispSegParamStrT *)arg;

                /* copy parameters from an user space to the kernel space */
                FAPEXCFDLSAF_COPY_TO_DRV(&params, pArg, sizeof(FAPEX_FPC_DispSegParamStrT));

                /* call FAPI (set segments) */
                if((params.mask & 0x0f) == 0x0f) {
                    ret = fpc_funcStr.SetDisplayWord(pfunc->pFAPICtxHdl,
                                                     params.data[3], params.data[2],
                                                     params.data[1], params.data[0],
                                                     (params.dot & 0x01), (params.dot & 0x02),
                                                     (params.dot & 0x04), (params.dot & 0x08));
                }
                else {
                    bitmsk = 0x08;
                    for(i=0; i<4; i++) {
                        if(params.mask & bitmsk) {
                            ret = fpc_funcStr.SetDigitAt(pfunc->pFAPICtxHdl,
                                                         params.data[i],
                                                         (params.dot & bitmsk), i);
                        }
                        bitmsk >>= 1;
                    }
                }
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_DIGIT:
            if(arg != (FAPEXFDLIOCARG4_T)NULL) {
                FAPEX_FPC_DigitParamStrT  params, *pArg;

                pArg = (FAPEX_FPC_DigitParamStrT *)(arg);

                /* copy parameters from an user space to the kernel space */
                FAPEXCFDLSAF_COPY_TO_DRV(&params, pArg, sizeof(FAPEX_FPC_DigitParamStrT));

                /* call FAPI (set segment Digit) */
                ret = fpc_funcStr.SetCipherAt(pfunc->pFAPICtxHdl, params.value, params.position);
            }
            break;

        case FAPEX_IOCCOM_FPC_GET_DIGIT:
            if(arg != (FAPEXFDLIOCARG4_T)NULL) {
                FAPEX_FPC_DigitParamStrT  params, *pArg;

                pArg = (FAPEX_FPC_DigitParamStrT *)(arg);

                /* copy parameters from an user space to the kernel space */
                FAPEXCFDLSAF_COPY_TO_DRV(&params, pArg, sizeof(FAPEX_FPC_DigitParamStrT));

                /* call FAPI (get segment Digit) */
                ret = fpc_funcStr.GetCipherAt(pfunc->pFAPICtxHdl, params.position);
                if(ret >= 0) {
                    params.value = ret;
                    ret = FAPI_OK;
                }
                /* copy parameters from the kernel space to an user space */
                FAPEXCFDLSAF_COPY_TO_USR((void *)arg, &params, sizeof(FAPEX_FPC_DigitParamStrT));
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_INCREMENT_DIGIT:
            {
                FAPEX_FPC_DigitParamStrT  params, *pArg;

                pArg = (FAPEX_FPC_DigitParamStrT *)(arg);

                /* copy parameters from an user space to the kernel space */
                FAPEXCFDLSAF_COPY_TO_DRV(&params, pArg, sizeof(FAPEX_FPC_DigitParamStrT));

                /* call FAPI (increment segment) */
                ret = fpc_funcStr.IncrementCipherAt(pfunc->pFAPICtxHdl, params.position);
                if(ret == FAPI_FPC_DIGIT_CARRY) {
                    ret = FAPI_OK;
                    params.carry = 1;
                }
                else {
                    params.carry = 0;
                }
                /* copy parameters from the kernel space to an user space */
                FAPEXCFDLSAF_COPY_TO_USR((void *)arg, &params, sizeof(FAPEX_FPC_DigitParamStrT));
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_DECREMENT_DIGIT:
            if(arg != (FAPEXFDLIOCARG4_T)NULL) {
                FAPEX_FPC_DigitParamStrT  params, *pArg;

                pArg = (FAPEX_FPC_DigitParamStrT *)(arg);

                /* copy parameters from an user space to the kernel space */
                FAPEXCFDLSAF_COPY_TO_DRV(&params, pArg, sizeof(FAPEX_FPC_DigitParamStrT));

                /* call FAPI (decrement segment) */
                ret = fpc_funcStr.DecrementCipherAt(pfunc->pFAPICtxHdl, params.position);
                if(ret == FAPI_FPC_DIGIT_CARRY) {
                    ret = FAPI_OK;
                    params.carry = -1;
                }
                else {
                    params.carry = 0;
                }
                /* copy parameters from the kernel space to an user space */
                FAPEXCFDLSAF_COPY_TO_USR((void *)arg, &params, sizeof(FAPEX_FPC_DigitParamStrT));
            }
            break;

        case FAPEX_IOCCOM_FPC_GET_DOT:
            if(arg != (FAPEXFDLIOCARG4_T)NULL) {
                FAPEX_FPC_DotParamStrT  params, *pArg;

                pArg = (FAPEX_FPC_DotParamStrT *)(arg);

                /* copy parameters from an user space to the kernel space */
                FAPEXCFDLSAF_COPY_TO_DRV(&params, pArg, sizeof(FAPEX_FPC_DotParamStrT));

                /* call FAPI (get segment Dot) */
                ret = fpc_funcStr.IsDotActiveAt(pfunc->pFAPICtxHdl, params.position);
                if(ret >= 0) {
                    params.actFlag = ret;
                    ret = FAPI_OK;
                }
                /* copy parameters from the kernel space to an user space */
                FAPEXCFDLSAF_COPY_TO_USR((void *)arg, &params, sizeof(FAPEX_FPC_DotParamStrT));
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_DOT_TOGGLE:
            {
                uint32_t  position = (uint32_t)arg;

                /* call FAPI (toggle segment Digit) */
                ret = fpc_funcStr.ToggleDotAt(pfunc->pFAPICtxHdl, position);
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_INTEGER_VALUE:
            {
                int32_t  value = (int32_t)arg;

                /* call FAPI (set integer value) */
                ret = fpc_funcStr.SetIntegerValue(pfunc->pFAPICtxHdl, value);
            }
            break;

        case FAPEX_IOCCOM_FPC_GET_INTEGER_VALUE:
            if(arg != (FAPEXFDLIOCARG4_T)NULL) {
                int32_t  value;

                /* call FAPI (get integer value) */
                value = fpc_funcStr.GetIntegerValue(pfunc->pFAPICtxHdl);
                if(value >= -999) {
                    /* copy parameters from the kernel space to an user space */
                    FAPEXCFDLSAF_COPY_TO_USR((void *)arg, &value, sizeof(int32_t));
                    ret = 0;
                }
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_INCREMENT_INTEGER_VALUE:
            {
                /* call FAPI (increment integer value) */
                ret = fpc_funcStr.IncrementIntegerValue(pfunc->pFAPICtxHdl);
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_DECREMENT_INTEGER_VALUE:
            {
                /* call FAPI (decrement integer value) */
                ret = fpc_funcStr.DecrementIntegerValue(pfunc->pFAPICtxHdl);
            }
            break;

        case FAPEX_IOCCOM_FPC_SET_SCROLL_TEXT:
            if(arg != (FAPEXFDLIOCARG4_T)NULL) {
                FAPEX_FPC_MessageParamStrT  params, *pArg;
                uint8_t  *text;

                pArg = (FAPEX_FPC_MessageParamStrT *)(arg);

                /* copy parameters from an user space to the kernel space */
                FAPEXCFDLSAF_COPY_TO_DRV(&params, pArg, sizeof(FAPEX_FPC_MessageParamStrT));

                text = FAPI_SYS_MALLOC(params.size * sizeof(uint8_t));
                if(text != NULL) {
                    /* copy parameters from an user space to the kernel space */
                    FAPEXCFDLSAF_COPY_TO_DRV(&text, params.message, params.size * sizeof(uint8_t));

                    /* call FAPI (scroll text) */
                    ret = fpc_funcStr.SetScrollText(pfunc->pFAPICtxHdl, text, params.delay);

                    FAPI_SYS_FREE(text);
                }
                else {
                    ret = FAPEX_FPC_ERR_OUT_OF_MEMORY;
                }
            }
            break;

#endif /* FAPI_FPC_CONNECT */

        case FAPEX_IOCCOM_FPC_GET_BUTTON_NOTIFY:
            if(arg != (FAPEXFDLIOCARG4_T)NULL) {
                if(pfunc->btn_enable_flag != 0) {
                    FAPEXCFDLSAF_EventStrT *btn_event_ptr;

                    btn_event_ptr = &pfunc->btn_event;

                    /* wait */
                    btn_event_ptr->mode       = FAPEXCFDLSAF_WAITEVENT_SYNC | FAPEXCFDLSAF_WAITEVENT_OR;
                    btn_event_ptr->wai_bitptn = pfunc->btn_enable_flag;
                    btn_event_ptr->tout       = 0;
                    ret = FAPEXCFDLSAF_WAIT_EVENT(btn_event_ptr);
                    if(ret != FAPI_ERR_TIMEOUT) {
                        /* copy parameters from the kernel space to an user space */
                        FAPEXCFDLSAF_COPY_TO_USR((void *)arg, &ret, sizeof(int32_t));
                        ret = 0;
                    }
                    else {
                        ret = FAPEX_FPC_ERR_TIMEOUT;
                    }
                }
                else {
                    ret = FAPEX_FPC_ERR_INVALID_STATUS;
                }
            }
            break;

        default:
            ;
    }

    return ret;
}

#if 0 /* not supported */
/*!
*******************************************************************************
**
** \brief  Poll method of this id's FDL.
**         This function is called with the systemcall "select".
**
** \param  file    The pointer to the struct file.
** \param  ptbl    An internal data.
**
******************************************************************************/
FAPEXFDLPLRET_T FAPEXFDLFPC_poll(FAPEXFDLPLARG1_T file, FAPEXFDLPLARG2_T ptbl)
{
    FAPEXFDLPLRET_T mask = 0;

    FAPEXDebugPrint(4, "[FAPEXFDLFPC_poll]\n");

    return mask;
}
#endif

#if 0 /* not supported */
/*!
*******************************************************************************
**
** \brief  Mmap method of this id's FDL.
**         This function is called with the systemcall "mmap".
**
** \param  file    The pointer to the struct file.
** \param  vma     system depend
**
******************************************************************************/
FAPEXFDLMMPRET_T FAPEXFDLFPC_mmap(FAPEXFDLMMPARG1_T file, FAPEXFDLMMPARG2_T vma)
{
#ifdef __LINUX__
    int32_t ret;

    if (vma->vm_pgoff != 0){
        return -EINVAL;
    }

    /* This area doen't swapout */
    vma->vm_flags |= VM_IO | VM_RESERVED;

    /* This area is IO area. Set noncache, and it doesn't dump to a core
       file of a process */
    if (file->f_flags & O_SYNC){
        vma->vm_page_prot = pgprot_noncached(vma->vm_page_prot);
        vma->vm_flags |= VM_IO;
    }

    ret = remap_pfn_range(vma, vma->vm_start, vma->vm_pgoff,
                  vma->vm_end - vma->vm_start, vma->vm_page_prot);

    if(ret != 0){
        return -EAGAIN;
    }
    return 0;
#else
    return -1;
#endif /* __LINUX__ */
}
#endif

/*!
*******************************************************************************
**
** \brief  Open this id's FDL.
**         This function is called with the systemcall "open". And this id's FDL 
**         are opened.
**
** \param  inode   The pointer to the struct inode.
** \param  file    The pointer to the struct file.
**
******************************************************************************/
FAPEXFDLOPENRET_T FAPEXFDLFPC_open (FAPEXFDLOPENARG1_T inode, FAPEXFDLOPENARG2_T file)
{
    FAPEXFDL_FPC_StrT  *pfunc;
    void    *pCfdlHdl;
    int32_t id;

    FAPEXDebugPrint(3, "[FAPEXFDLFPC_open] file:0x%08x,private_data:0x%08x\n",
                       (uint32_t)file, (uint32_t)file->private_data);

    if(file->private_data == NULL){
        id = FAPEXCFDLSAF_GETID(inode);
        FAPEXDebugPrint(3, "[FAPEXFDLFPC_open] minor_no:%d\n", id);

        /* Get the context base of the CFDL. */
        pCfdlHdl = (void*)FAPEXCFDL_GetCfdlHdl();
        FAPEXDebugPrint(3, "[FAPEXFDLFPC_open] pCfdlHdl:0x%08x\n", (uint32_t)(pCfdlHdl));

        /* Get the context base of this id's FDL. */
        pfunc = (FAPEXFDL_FPC_StrT*)FAPEXCFDL_GetFdlHdl(pCfdlHdl, id);
        file->private_data = pfunc;
        FAPEXDebugPrint(3, "[FAPEXFDLFPC_open] pFdlHdl:0x%08x\n", (uint32_t)(pfunc));
#ifdef __LINUX__
        kref_init(&pfunc->kref);
#endif
    }
    else {
        pfunc = (FAPEXFDL_FPC_StrT *)file->private_data;
#ifdef __LINUX__
        kref_get(&pfunc->kref);
#endif
    }

    /* increment our usage count for the device */
    pfunc->used_count++;

    FAPEXDebugPrint(3, "[FAPEXFDLFPC_open] fapex_fdlfpc was opened : used_counter %d.\n",
                       pfunc->used_count);

    return 0;
}

/*!
*******************************************************************************
**
** \brief  delete this FDL id's module.
**         This function is called with the systemcall "close". And this id's FDL
**         are released.
**
** \param  kref    The pointer to the kref structure.
**
******************************************************************************/
#ifdef __LINUX__
static void fdlfpc_delete(struct kref *kref)
{
    FAPEXFDL_FPC_StrT   *pfunc;
    int32_t  ret = 0;

    pfunc = container_of(kref, FAPEXFDL_FPC_StrT, kref);
#else
static int32_t fdlfpc_delete(FAPEXFDL_FPC_StrT *pfunc)
{
    int32_t  ret = 0;
#endif

    if(pfunc->btn_enable_flag != 0) {
        /* set end event */
        ret = FAPEXCFDLSAF_SET_EVENT( &pfunc->btn_event,
                                      FAPEX_FPC_EVENT_END,
                                      FAPEXCFDLSAF_WAITEVENT_OR );
        if(ret < 0) {
            ret = FAPEX_FPC_ERR_INVALID_STATUS;
            goto fdlfpc_delete_end;
        }
        pfunc->btn_enable_flag = 0;
    }

    if(pfunc->pFAPICtxHdl != NULL) {
#ifdef FAPI_FPC_CONNECT
        /* close sequence */
        ret = fpc_funcStr.Close(pfunc->pFAPICtxHdl);
        if(ret != FAPI_OK) {
            goto fdlfpc_delete_end;
        }
#endif /* FAPI_FPC_CONNECT */
        pfunc->pFAPICtxHdl = NULL;
    }

    FAPEXCFDLSAF_DELETE_EVENT(&pfunc->btn_event);

fdlfpc_delete_end:
#ifdef __LINUX__
    pfunc->close_result = ret;
#else
    return ret;
#endif
}

/*!
*******************************************************************************
**
** \brief  Release this FDL id's module.
**         This function is called with the systemcall "close". And this id's FDL
**         are released.
**
** \param  inode   The pointer to the struct inode.
** \param  file    The pointer to the struct file.
**
******************************************************************************/
FAPEXFDLRELRET_T FAPEXFDLFPC_release (FAPEXFDLRELARG1_T inode, FAPEXFDLRELARG2_T file)
{
    FAPEXFDL_FPC_StrT  *pfunc;
    FAPEXFDLRELRET_T   ret = 0;

    /* Get the context base of this id's FDL. */
    pfunc = (FAPEXFDL_FPC_StrT*)(file->private_data);

    if(pfunc != NULL) {
        /* decrement the count on our device */
        pfunc->used_count--;
#ifdef __LINUX__
        ret = kref_put(&pfunc->kref, fdlfpc_delete);
        if(ret != 0) {
            ret = pfunc->close_result;
        }
#else
        ret = fdlfpc_delete(pfunc);
#endif

        FAPEXDebugPrint(3, "[FAPEXFDLFPC_release] : used_count %d\n",
                           pfunc->used_count);
    }
    FAPEXFDL_RETVAL(ret);
}

/*--------------------------------------------------------*/
/* The file operations of this FDL module.                */
/*--------------------------------------------------------*/
struct file_operations fapex_fdlfpc_fops;

/*!
*******************************************************************************
**
** \brief  Initialize process of the FDL module.
**         This function is called when the FDL module is loaded. It is executed
**         only one times.
**         On Linux, this function is registered to the kernel using "module_init".
**         And user application doesn't call this function. If do "insmod" command,
**         this is called by the kernel.
**         On RTOS, user application has to call this function.
**
** \param  void (can't set any argument)
**
******************************************************************************/
int32_t FAPEXFDLFPC_init(void)
{
    int32_t ret;
    int32_t count;
    FAPEXFDL_FPC_StrT   *pfunc;
    FAPEXCFDL_UtilStrT  utility;
#ifdef ALLOCATE_DYNAMIC_MEMORY
    FAPEXFDL_FPC_StrT   *pfunc0;
#endif

    FAPEXDebugPrint(1, "[FAPEXFDLFPC_init]\n");

    /* set struct file_operations */
    fapex_fdlfpc_fops.owner   = THIS_MODULE;
    fapex_fdlfpc_fops.open    = FAPEXFDLFPC_open;
//  fapex_fdlfpc_fops.read    = FAPEXFDLFPC_read;
//  fapex_fdlfpc_fops.write   = FAPEXFDLFPC_write;
    fapex_fdlfpc_fops.ioctl   = FAPEXFDLFPC_ioctl;
//  fapex_fdlfpc_fops.poll    = FAPEXFDLFPC_poll;
//  fapex_fdlfpc_fops.mmap    = FAPEXFDLFPC_mmap;
    fapex_fdlfpc_fops.release = FAPEXFDLFPC_release;

#ifdef ALLOCATE_DYNAMIC_MEMORY
    pfunc = (FAPEXFDL_FPC_StrT*)FAPI_SYS_MALLOC(sizeof(FAPEXFDL_FPC_StrT)*(FAPEXDEV_FPC_DESCRIPTOR_NUM));
    if(pfunc == NULL) {
        return FAPEX_FPC_ERR_OUT_OF_MEMORY;
    }
    pfunc0 = pfunc;
#else
    pfunc = FAPIGLD_FDLFPCCtx;
#endif /* ALLOCATE_DYNAMIC_MEMORY */
    FAPEXCFDLSAF_CLEAR_MEMORY(pfunc, sizeof(FAPEXFDL_FPC_StrT)*(FAPEXDEV_FPC_DESCRIPTOR_NUM));

    for(count=FAPEXDEV_FPC_MINOR_FIRST; count<=FAPEXDEV_FPC_MINOR_LAST; count++){
        /* Register this id's FDL device to CFDL. */
        ret = FAPEXCFDL_RegisterFdl(&fapex_fdlfpc_fops, pfunc, &utility, count);
        if(ret) {
#ifdef ALLOCATE_DYNAMIC_MEMORY
            FAPI_SYS_FREE(pfunc0);
#endif
            FAPEXDebugPrint(2, "[FAPEXFDLFPC_init] FAPEXCFDL_RegisterFdl:error %d\n", ret);
            return ret;
        }
        pfunc ++;
    }

#if defined(FAPI_FPC_CONNECT) && !defined(FUJITSU_MB86H60_INPUT_FPCDEV)
    FAPEXDebugPrint(1, "call FAPEXCFG_FPC_Init\n");

    /* call FAPI (initialize) */
    ret = FAPEXCFG_FPC_Init();
#else
    ret = 0;
#endif /* FAPI_FPC_CONNECT && !FUJITSU_MB86H60_INPUT_FPCDEV */

    FAPEXDebugPrint(1, "[FAPEXFDLFPC_init] fapex_fdlfpc was loaded. %d\n", ret);

    return ret;
}

/*!
*******************************************************************************
**
** \brief  Cleanup process of the FDL module.
**         This function is called when the FDL module is unloaded. It is executed
**         only one times.
**         On Linux, this function is registered to the kernel using "module_exit".
**         And user application doesn't call this function. If do "rmmod" command, 
**         this is called by the kernel.
**         On RTOS, user application has to call this function.
**
** \param  void (can't set any argument)
**
******************************************************************************/
void FAPEXFDLFPC_cleanup(void)
{
    int32_t count;

    FAPEXDebugPrint(1, "[FAPEXFDLFPC_cleanup]\n");

#if defined(FAPI_FPC_CONNECT) && !defined(FUJITSU_MB86H60_INPUT_FPCDEV)
    /* call FAPI API (cleanup) */
    FAPEXCFG_FPC_Cleanup();

    FAPEXDebugPrint(1, "end FAPEXCFG_FPC_Cleanup\n");
#endif /* FAPI_FPC_CONNECT && !FUJITSU_MB86H60_INPUT_FPCDEV */

#ifdef ALLOCATE_DYNAMIC_MEMORY
    {
        void *pCfdlHdl;
        FAPEXFDL_FPC_StrT *pfunc;

        pCfdlHdl = (void*)FAPEXCFDL_GetCfdlHdl();
        pfunc    = (FAPEXFDL_FPC_StrT*)FAPEXCFDL_GetFdlHdl(pCfdlHdl, FAPEXDEV_FPC_MINOR_FIRST);

        /* relase the FDL context */
        if(pfunc != NULL) {
            FAPI_SYS_FREE(pfunc);
        }
    }
#endif /* ALLOCATE_DYNAMIC_MEMORY */

    /* cleanup sequence (common this FDL) */
    for(count=FAPEXDEV_FPC_MINOR_FIRST; count<=FAPEXDEV_FPC_MINOR_LAST; count++) {
        /* Unregister this id's FDL device to CFDL. */
        FAPEXCFDL_UnregisterFdl(count);
    }

    FAPEXDebugPrint(1, "[FAPEXFDLFPC_cleanup] fapex_fdlfpc was unloaded.\n");
    return;
}

#ifdef __LINUX__
/*******************************
 MACRO (Linux dep.)
********************************/
#ifdef BUILD_AS_MODULE
module_init(FAPEXFDLFPC_init);
module_exit(FAPEXFDLFPC_cleanup);

MODULE_LICENSE("Proprietary. Fujitsu Semiconductor.");
MODULE_DESCRIPTION("FAPI driver (fapex_fdlfpc object)");
#endif /* BUILD_AS_MODULE */
#endif /* __LINUX__ */
