/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FDL gpio Decoder header file (private)
*/

#ifndef _FAPEX_FDLGPIO_PRIV_H
#define _FAPEX_FDLGPIO_PRIV_H

#include "fapex/abst_libgpio.h"

/*!
*************************************************************************
** \brief FDL GPIO context structure
*************************************************************************/
typedef struct {
    int32_t id;             //!< id
    int32_t used_count;     //!< used count
#ifdef __LINUX__
    struct kref kref;           //!< kref struct
    int32_t     close_result;   //!< return code at closing
#endif

    void    *pCfdlHdl;      //!< The pointer to the CFDL context
    void    *pFAPICtxHdl;   //!< FAPI driver's context

} FAPEXFDL_GPIO_StrT;

#endif /* !_FAPEX_FDLGPIO_PRIV_H */
