/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FDL HDMI_CEC header file (private)
*/

#ifndef _FAPEX_FDLHDMICEC_PRIV_H
#define _FAPEX_FDLHDMICEC_PRIV_H

#include "fapex/abst_libhdmicec.h"

/*!
*************************************************************************
** \brief FDL HDMICEC context structure
*************************************************************************/
typedef struct {
    int32_t id;           //!< id
    int32_t used_count;   //!< used count
#ifdef __LINUX__
    struct kref kref;     //!< kref struct
#endif

    void    *pCfdlHdl;    //!< The pointer to the CFDL context
    int32_t open_flag;    //!< HDMI_CEC fapi module open flag
    int32_t status;       //!< HDMI_CEC status

    FAPEXCFDLSAF_EventStrT  dt_event;      //!< data event control

} FAPEXFDL_HDMICEC_StrT;

/*! \brief HDMICEC event type */
#define FAPEXFDL_HDMICEC_EVENT_NONE     (0x0000)    //!< none event */
#define FAPEXFDL_HDMICEC_EVENT_SEND     (0x0001)    //!< data send event
#define FAPEXFDL_HDMICEC_EVENT_RECEIVE  (0x0002)    //!< data receive event */

#endif /* !_FAPEX_FDLHDMICEC_PRIV_H */
