/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 * 
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 FDL Video encoder header file (private)
*/

#ifndef _FAPEX_FDLVIENC_PRIV_H
#define _FAPEX_FDLVIENC_PRIV_H

#include "fapi/drv_vienc.h"

/*!
*************************************************************************
** \brief FDL Vienc common context structure
*************************************************************************/
typedef struct {
    int32_t id;         //!< id
    int32_t used_count; //!< used count
#ifdef __LINUX__
    struct kref kref;   //!< kref struct
#endif

    void    *pCfdlHdl;  //!< The pointer to the CFDL context
    int32_t status;     //!< VIENC block status

    int32_t system_mode;    //!< Video system mode (frame size, frame rate)

    volatile uint32_t   enable_channel;     //!< enable VIENC channel flag
    volatile uint32_t   running_channel;    //!< running channel flag

    FAPI_SYS_SemaphoreT  cmn_sem;   //!< Semaphore for common parameter control

} FAPEXFDL_VIENC_CmnStrT;

/*!
*************************************************************************
** \brief FDL Vienc sub context structure
*************************************************************************/
typedef struct{
    int32_t     id;          //!< id
    int32_t     used_count;  //!< used count
#ifdef __LINUX__
    struct kref kref;        //!< kref struct
#endif

    void        *pCfdlHdl;       //!< The pointer to the CFDL context
    int32_t     status;          //!< VIENC channel status

    void        *pCmnHdl;        //!< the pointer to the VIENC common context
    void        *pFAPICtxHdl;    //!< FAPI driver's context

    int32_t     enc_type;        //!< analog encoder type (FAPI_VIENC_EncoderEnumT)

} FAPEXFDL_VIENC_SubStrT;

#endif /* !_FAPEX_FDLVIENC_PRIV_H */
