/*!
*************************************************************************
**
** \file    fapex_boot_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
** 
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_BOOT_FUNC_H
#define _FAPEX_BOOT_FUNC_H

#include "fapi/drv_boot.h"

typedef struct {
    int32_t          (*Init)(void);
    void             (*Exit)(void);
    FAPI_SYS_HandleT (*Open)(const FAPI_BOOT_OpenParamsT* paramsPtr,int32_t* errorCodePtr);
    int32_t          (*Close)(FAPI_SYS_HandleT handle);
    int32_t          (*GetInfo)(FAPI_SYS_HandleT handle,FAPI_BOOT_InfoT* resultBuffer);
    int32_t          (*GetBootMode)(FAPI_SYS_HandleT handle,uint32_t* modeBuffer);
    int32_t          (*GetBootDevice)(FAPI_SYS_HandleT handle,uint32_t* deviceBuffer);
    int32_t          (*LoadImageByVersion)(FAPI_SYS_HandleT handle,uint32_t imageVersion,uint32_t targetAddress);
    int32_t          (*GetImageInfoByVersion)(FAPI_SYS_HandleT handle,uint32_t imageVersion,FAPI_BOOT_ImageHeaderT* infoBuffer);
} FAPEX_BOOT_FuncStrT;

#endif /* _FAPEX_BOOT_FUNC_H */
