/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 CFDL header file (public)
*/
#ifndef _FAPEX_CFDL_H
#define _FAPEX_CFDL_H

#ifndef __LINUX__
/*---------------------------------------------------------------------------*/
/* file operation structure (for RTOS)                                       */
/* On Linux, it is pre-defined by kernel.                                    */
/*---------------------------------------------------------------------------*/
struct file_operations {
    void *owner;           /*!< owner */
    FAPEXFDLOPENRET_T (*open)   (FAPEXFDLOPENARG1_T, FAPEXFDLOPENARG2_T); /*!< open method */
    FAPEXFDLRELRET_T  (*release)(FAPEXFDLRELARG1_T, FAPEXFDLRELARG2_T);   /*!< release method */
    FAPEXFDLREADRET_T (*read)   (FAPEXFDLREADARG1_T, FAPEXFDLREADARG2_T, FAPEXFDLREADARG3_T, FAPEXFDLREADARG4_T); /*!< read method */
    FAPEXFDLWRTRET_T  (*write)  (FAPEXFDLWRTARG1_T, FAPEXFDLWRTARG2_T, FAPEXFDLWRTARG3_T, FAPEXFDLWRTARG4_T);     /*!< write method */
    FAPEXFDLIOCRET_T  (*ioctl)  (FAPEXFDLIOCARG1_T, FAPEXFDLIOCARG2_T, FAPEXFDLIOCARG3_T, FAPEXFDLIOCARG4_T);     /*!< ioctl method */
    FAPEXFDLPLRET_T   (*poll)   (FAPEXFDLPLARG1_T, FAPEXFDLPLARG2_T);     /*!< poll method */
    int32_t           (*mmap)   (FAPEXfile_S*, FAPEXvm_area_S*);          /*!< mmap method */
};

/*---------------------------------------------------------------------------*/
/* vm_area_struct structure (for RTOS)                                       */
/* On Linux, it is pre-defined by kernel.                                    */
/*---------------------------------------------------------------------------*/
struct vm_area_struct {
    void        *vm_start;
    uint32_t    vm_length;
    uint32_t    vm_offset;
};

#define THIS_MODULE (0)
#endif /* !__LINUX__ */

/*---------------------------------------------------------------------------*/
/* CFDL utility register structure (container)                               */
/*---------------------------------------------------------------------------*/
typedef struct {
    int dummy;                       /*!< dummy data (temporal) */
} FAPEXCFDL_UtilStrT;


#ifdef __cplusplus
extern "C" {
#endif

/* prototype */
void*   FAPEXCFDL_GetCfdlHdl(void);
int32_t FAPEXCFDL_RegisterFdl(struct file_operations *fops, void *pFdlCtx,
                              FAPEXCFDL_UtilStrT *pUtility, int32_t id);
int32_t FAPEXCFDL_UnregisterFdl(int32_t id);
void*   FAPEXCFDL_GetFdlHdl(void *pCfdlHdl, int32_t id);

#ifdef __cplusplus
}
#endif


#endif /* !_FAPEX_CFDL_H */
