/*!
*************************************************************************
**
** \file    fapex_desc_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_DESC_FUNC_H
#define _FAPEX_DESC_FUNC_H

#include "fapi/drv_desc.h"
#include "fapi/drv_desc_ca.h"

typedef struct {
    int32_t          (*Init)(void);
    void             (*Exit)(void);
    FAPI_SYS_HandleT (*Open)(FAPI_DESC_OpenParamsT* pParams,
                             int32_t* errorCodePtr);
    int32_t          (*Close)(FAPI_SYS_HandleT handle);
    int32_t          (*SetKeys)(FAPI_SYS_HandleT handle,
                                uint8_t* evenKey, uint32_t evenKeyLength,
                                uint8_t* oddKey,  uint32_t oddKeyLength,
                                uint8_t* inVector, uint32_t inVectorLength );
    int32_t          (*Start)(FAPI_SYS_HandleT handle);
    int32_t          (*Stop)(FAPI_SYS_HandleT handle);
    int32_t          (*SetSystemKey)( FAPI_SYS_HandleT handle,
                                      uint8_t* systemKey,  uint32_t systemKeyLength );
    int32_t          (*SetInitialVector)( FAPI_SYS_HandleT handle,
                                          uint8_t* inVector,  uint32_t inVectorLength );
    int32_t          (*SetKeyladderIndex)( FAPI_SYS_HandleT handle, uint32_t blockIndex );
    int32_t          (*RunKeyladder)( FAPI_SYS_HandleT handle,
                                      FAPI_DESC_KeyladderEnumT keyladderMode,
                                      uint8_t* keyladderData0,
                                      uint8_t* keyladderData1,
                                      uint8_t* keyladderData2,
                                      uint32_t isEvenKey );
    int32_t          (*SetKeyladderHostKey)( FAPI_SYS_HandleT handle,
                                              uint8_t* hostKey );
} FAPEX_DESC_FuncStrT;

#endif /* _FAPEX_DESC_FUNC_H */
