/*!
*************************************************************************
**
** \file    fapex_func_ext.h
**
** \brief   function pointer external definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_FUNC_EXT_H
#define _FAPEX_FUNC_EXT_H

#include "fapex_audec_func.h"
#include "fapex_auout_func.h"
#include "fapex_bm_func.h"
#include "fapex_board_func.h"
#include "fapex_boards_func.h"
#include "fapex_boot_func.h"
#include "fapex_clkpwr_func.h"
#include "fapex_desc_func.h"
#include "fapex_dma_func.h"
#include "fapex_flash_func.h"
#include "fapex_fpc_func.h"
#include "fapex_gpio_func.h"
#include "fapex_gpreg_func.h"
#include "fapex_hdmi_func.h"
#include "fapex_hdmicec_func.h"
#include "fapex_i2c_func.h"
#include "fapex_icc_func.h"
#include "fapex_intr_func.h"
#include "fapex_ir_func.h"
#include "fapex_mmu_func.h"
#include "fapex_ssp_func.h"
#include "fapex_sync_func.h"
#include "fapex_timer_func.h"
#include "fapex_tsd_func.h"
#include "fapex_ttx_func.h"
#include "fapex_uart_func.h"
#include "fapex_upi_func.h"
#include "fapex_videc_func.h"
#include "fapex_vienc_func.h"
#include "fapex_viscale_func.h"

extern FAPEX_AUDEC_FuncStrT     audec_funcStr;
extern FAPEX_AUOUT_FuncStrT     auout_funcStr;
extern FAPEX_BM_FuncStrT        bm_funcStr;
extern FAPEX_BOARD_FuncStrT     board_funcStr;
extern FAPEX_BOARDS_FuncStrT    boards_funcStr;
extern FAPEX_BOOT_FuncStrT      boot_funcStr;
extern FAPEX_CLKPWR_FuncStrT    clkpwr_funcStr;
extern FAPEX_DESC_FuncStrT      desc_funcStr;
extern FAPEX_DMA_FuncStrT       dma_funcStr;
extern FAPEX_FLASH_FuncStrT     flash_funcStr;
extern FAPEX_FPC_FuncStrT       fpc_funcStr;
extern FAPEX_GPIO_FuncStrT      gpio_funcStr;
extern FAPEX_GPREG_FuncStrT     gpreg_funcStr;
extern FAPEX_HDMI_FuncStrT      hdmi_funcStr;
extern FAPEX_HDMICEC_FuncStrT   hdmicec_funcStr;
extern FAPEX_I2C_FuncStrT       i2c_funcStr;
extern FAPEX_ICC_FuncStrT       icc_funcStr;
extern FAPEX_INTR_FuncStrT      intr_funcStr;
extern FAPEX_IR_FuncStrT        ir_funcStr;
extern FAPEX_MMU_FuncStrT       mmu_funcStr;
extern FAPEX_SSP_FuncStrT       ssp_funcStr;
extern FAPEX_SYNC_FuncStrT      sync_funcStr;
extern FAPEX_TIMER_FuncStrT     timer_funcStr;
extern FAPEX_TSD_FuncStrT       tsd_funcStr;
extern FAPEX_TTX_FuncStrT       ttx_funcStr;
extern FAPEX_UART_FuncStrT      uart_funcStr;
extern FAPEX_UPI_FuncStrT       upi_funcStr;
extern FAPEX_VIDEC_FuncStrT     videc_funcStr;
extern FAPEX_VIENC_FuncStrT     vienc_funcStr;
extern FAPEX_VISCALE_FuncStrT   viscale_funcStr;

#endif /* _FAPEX_FUNC_EXT_H */
