/*!
*************************************************************************
**
** \file    fapex_gpio_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_GPIO_FUNC_H
#define _FAPEX_GPIO_FUNC_H

#include "fapi/drv_gpio.h"

typedef struct {
    int32_t          (*Init)( void );
    void             (*Exit)( void );
    void             (*SetPinFunction)( uint32_t pin, uint32_t function );
    uint32_t         (*Isr)( void );
    void             (*Bsr)( uint32_t value );
    FAPI_SYS_HandleT (*Open)( FAPI_GPIO_OpenParamsT* pParams, int32_t* errorCodePtr );
    int32_t          (*Close)( FAPI_SYS_HandleT handle );
    int32_t          (*ReadBit)( FAPI_SYS_HandleT handle );
    int32_t          (*WriteBit)( FAPI_SYS_HandleT handle, int32_t bit );
    uint32_t         (*GetPinByFunction)( uint32_t function );
} FAPEX_GPIO_FuncStrT;
extern FAPEX_GPIO_FuncStrT gpio_funcStr;
#endif /* _FAPEX_GPIO_FUNC_H */
