/*!
*************************************************************************
**
** \file    fapex_gpreg_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_GPREG_FUNC_H
#define _FAPEX_GPREG_FUNC_H

#include "fapi/drv_gpreg.h"

typedef struct {
    int32_t          (*Init)( void );
    void             (*Exit)( void );
    FAPI_SYS_HandleT (*Open)( const FAPI_GPREG_OpenParamsT* pParams, int32_t* errorCodePtr );
    int32_t          (*Close)( FAPI_SYS_HandleT handlePtr );
    int32_t          (*Read)( FAPI_SYS_HandleT handlePtr );
    int32_t          (*Write)( FAPI_SYS_HandleT handlePtr, uint32_t data );
    int32_t          (*LockMutex)( FAPI_SYS_HandleT handlePtr );
    int32_t          (*UnlockMutex)( FAPI_SYS_HandleT handlePtr );
} FAPEX_GPREG_FuncStrT;

#endif /* _FAPEX_GPREG_FUNC_H */
