/*!
*************************************************************************
**
** \file    fapex_hdmicec_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_HDMICEC_FUNC_H
#define _FAPEX_HDMICEC_FUNC_H

#include "fapi/drv_hdmi_cec.h"

typedef struct {
    int32_t          (*Init)(void);
    void             (*Exit)(void);
    int32_t          (*Open)(void);
    void             (*Close)(void);
    int32_t          (*SetCecConfigParameters)(FAPI_HDMI_CECConfigParamT* pCECConfParams);
    int32_t          (*SetCecMessageParameters)(uint32_t initiatorLogicalAddr,
                                                uint32_t followerLogicalAddr,
                                                uint32_t opcodeName,
                                                FAPI_HDMI_CECMessageParamsT* pCECParams);
    int32_t          (*GetCecMessageParameters)(uint32_t* InitiatorLogicalAddr,
                                                uint32_t* message,
                                                uint32_t* RecMsgNum,
                                                FAPI_HDMI_CECMessageParamsT *pCECParams);
    int32_t          (*SendCecMessage)(void);
    int32_t          (*ReceivingCecMessage)(void);
    uint32_t         (*CheckCecSendStatus)( void );
    uint32_t         (*CheckCecReceiveStatus)( void );
    void             (*SetCecLogicalAddress)( uint8_t MyDevLogicalAddr );
    uint32_t         (*GetCecLogicalAddress)( void );
} FAPEX_HDMICEC_FuncStrT;

#endif /* _FAPEX_HDMICEC_FUNC_H */
