/*!
*************************************************************************
**
** \file    fapex_intr_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_INTR_FUNC_H
#define _FAPEX_INTR_FUNC_H

#include "fapi/drv_intr.h"

typedef struct {
    int32_t  (*Init)( void );
    void     (*Exit)( void );
    void     (*SetReceiver)( uint32_t irqNo, uint32_t receiverCPU );
    int32_t  (*EnableIrqCtrl)( uint32_t irqNo );
    int32_t  (*DisableIrqCtrl)( uint32_t irqNo );
    int32_t  (*ThrowSwi)( uint32_t swiNo );
    int32_t  (*ThrowPollingModeIrq)( uint32_t toCPU );
    void     (*RegisterPipeCallback)( FAPI_INTR_PipeCallbackT callbackFunction );
    int32_t  (*WritePipe)( uint32_t value, uint32_t toCPU, uint32_t timeout );
    uint32_t (*Isr31)( void );
#ifndef __LINUX__
    void     (*SetPriority)( uint32_t irqNo, uint32_t priority );
    int32_t  (*RegisterIrq)( uint32_t irqNo, FAPI_INTR_IsrFuncT isrFunc, FAPI_INTR_BsrFuncT bsrFunc );
    int32_t  (*UnregisterIrq)( uint32_t irqNo );
    int32_t  (*RegisterSwi)( uint32_t swiNo, FAPI_INTR_SwiFuncT swiFunc );
    int32_t  (*UnregisterSwi)( uint32_t swiNo );
#endif /* !__LINUX__ */
} FAPEX_INTR_FuncStrT;

#endif /* _FAPEX_INTR_FUNC_H */
