/*!
*************************************************************************
**
** \file    fapex_ssp_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_SSP_FUNC_H
#define _FAPEX_SSP_FUNC_H

#include "fapi/drv_ssp.h"

typedef struct {
    int32_t           (*Init)(void);
    void              (*Exit)(void);
    uint32_t          (*Isr)(void);
    void              (*Bsr)(uint32_t privData);
    FAPI_SYS_HandleT  (*Open)(const FAPI_SSP_OpenParamsT* paramsPtr,
                              int32_t* errorCodePtr);
    int32_t           (*Close)(FAPI_SYS_HandleT handle);
    int32_t           (*SetFrameFormat)(const FAPI_SYS_HandleT handle,
                                        const FAPI_SSP_FrameFormatT* frameFormatPtr);
    int32_t           (*SetSpeed)(const FAPI_SYS_HandleT handle,
                                  const uint32_t serialClock,
                                  const uint32_t prescale);
    int32_t           (*GetData)(FAPI_SYS_HandleT handle,
                                 void* txDataPtr,
                                 const uint32_t txDataLength,
                                 void* rxDataPtr,
                                 const uint32_t rxDataLength);
    int32_t           (*Read)(FAPI_SYS_HandleT handle,
                              void* rxDataPtr,
                              const uint32_t  rxDataLength);
    int32_t           (*Write)(const FAPI_SYS_HandleT handle,
                               void* txDataPtr,
                               const uint32_t  txDataLength);
} FAPEX_SSP_FuncStrT;

#endif /* _FAPEX_SSP_FUNC_H */
