/*
 *
 * \attention  This program is provided as is. You can redistribute it and/or
 * modify it. Fujitsu Semiconductor Limited accepts no responsibility or
 * liability for any errors or omissions.
 *
 * Copyright (C) 2008-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
 */
/*
 types
 */

#ifndef _FAPEX_TYPES_H
#define _FAPEX_TYPES_H

#ifndef __LINUX__

#include "fapi/sys_services.h"
#include "rtos/rtos.h"

typedef int32_t               FAPEXinode_S;
typedef struct file           FAPEXfile_S;
typedef struct vm_area_struct FAPEXvm_area_S;

/* poll adapter */
typedef int32_t   FAPEXPLRET_T;
typedef int32_t   FAPEXPLARG1_T;
typedef void*     FAPEXPLARG2_T;

/* open method */
typedef int32_t       FAPEXFDLOPENRET_T;
typedef FAPEXinode_S  FAPEXFDLOPENARG1_T;
typedef FAPEXfile_S*  FAPEXFDLOPENARG2_T;

/* release method */
typedef int32_t       FAPEXFDLRELRET_T;
typedef FAPEXinode_S  FAPEXFDLRELARG1_T;
typedef FAPEXfile_S*  FAPEXFDLRELARG2_T;

/* read method */
typedef int32_t       FAPEXFDLREADRET_T;
typedef FAPEXfile_S*  FAPEXFDLREADARG1_T;
typedef void*         FAPEXFDLREADARG2_T;
typedef int32_t       FAPEXFDLREADARG3_T;
typedef void*         FAPEXFDLREADARG4_T;

/* write method */
typedef int32_t       FAPEXFDLWRTRET_T;
typedef FAPEXfile_S*  FAPEXFDLWRTARG1_T; 
typedef const void*   FAPEXFDLWRTARG2_T; 
typedef int32_t       FAPEXFDLWRTARG3_T;
typedef void*         FAPEXFDLWRTARG4_T;

/* ioctl method */
typedef int32_t       FAPEXFDLIOCRET_T;
typedef FAPEXinode_S  FAPEXFDLIOCARG1_T;
typedef FAPEXfile_S*  FAPEXFDLIOCARG2_T;
typedef uint32_t      FAPEXFDLIOCARG3_T;
typedef uint32_t      FAPEXFDLIOCARG4_T;

/* poll method */
typedef uint32_t      FAPEXFDLPLRET_T;
typedef FAPEXfile_S*  FAPEXFDLPLARG1_T;
typedef void*         FAPEXFDLPLARG2_T;

/* mmap method */
typedef int32_t          FAPEXFDLMMPRET_T;
typedef FAPEXfile_S*     FAPEXFDLMMPARG1_T;
typedef FAPEXvm_area_S*  FAPEXFDLMMPARG2_T;

/** sys **/
/* semaphore */
typedef int32_t    FAPEXCFDLSAF_SemaphoreT;
typedef int32_t    FAPEXCFDLSAF_SemValT;

/* wait event */
typedef RTOS_MailqueueT     FAPEXCFDLSAF_EventT;

/* spin lock */
typedef RTOS_SemaphoreT     FAPEXCFDLSAF_SpnLockStrT;

#else /* !__LINUX__ */

typedef struct inode*         FAPEXinode_S;
typedef struct file           FAPEXfile_S;
typedef struct vm_area_struct FAPEXvm_area_S;

/* open method */
typedef int32_t       FAPEXFDLOPENRET_T;
typedef FAPEXinode_S  FAPEXFDLOPENARG1_T;
typedef FAPEXfile_S*  FAPEXFDLOPENARG2_T;

/* release method */
typedef int32_t       FAPEXFDLRELRET_T;
typedef FAPEXinode_S  FAPEXFDLRELARG1_T;
typedef FAPEXfile_S*  FAPEXFDLRELARG2_T;

/* read method */
typedef ssize_t       FAPEXFDLREADRET_T;
typedef FAPEXfile_S*  FAPEXFDLREADARG1_T;
typedef char __user*  FAPEXFDLREADARG2_T;
typedef size_t        FAPEXFDLREADARG3_T;
typedef loff_t*       FAPEXFDLREADARG4_T;

/* write method */
typedef ssize_t             FAPEXFDLWRTRET_T;
typedef FAPEXfile_S*        FAPEXFDLWRTARG1_T;
typedef const char __user*  FAPEXFDLWRTARG2_T;
typedef size_t              FAPEXFDLWRTARG3_T;
typedef loff_t*             FAPEXFDLWRTARG4_T;

/* ioctl method */
typedef int32_t        FAPEXFDLIOCRET_T;
typedef FAPEXinode_S   FAPEXFDLIOCARG1_T;
typedef FAPEXfile_S*   FAPEXFDLIOCARG2_T;
typedef unsigned int   FAPEXFDLIOCARG3_T;
typedef unsigned long  FAPEXFDLIOCARG4_T;

/* poll method */
typedef uint32_t      FAPEXFDLPLRET_T;
typedef FAPEXfile_S*  FAPEXFDLPLARG1_T;
typedef poll_table*   FAPEXFDLPLARG2_T;

/* mmap method */
typedef int32_t          FAPEXFDLMMPRET_T;
typedef FAPEXfile_S*     FAPEXFDLMMPARG1_T;
typedef FAPEXvm_area_S*  FAPEXFDLMMPARG2_T;

/** sys **/
/* semaphore */
typedef struct semaphore   FAPEXCFDLSAF_SemaphoreT;
typedef int32_t            FAPEXCFDLSAF_SemValT;

/* wait event */
typedef wait_queue_head_t  FAPEXCFDLSAF_EventT;

/* spin lock */
typedef spinlock_t  FAPEXCFDLSAF_SpnLockStrT;

#endif /* !__LINUX__ */

#endif /* !_FAPEX_TYPES_H */

