/*!
*************************************************************************
**
** \file    fapex_uart_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_UART_FUNC_H
#define _FAPEX_UART_FUNC_H

#include "fapi/drv_uart.h"

typedef struct {
    int32_t          (*Init)( void );
    void             (*Exit)( void );
    uint32_t         (*Isr)( void );
    void             (*SetStdioBlockIndex)( uint32_t index );
    void             (*SetClockFrequency)( uint32_t freqencyHz );
    void             (*SetInterruptMode)( uint32_t index, uint32_t mode );
    void             (*SetBaudrate)( uint32_t index, uint32_t baudrate );
    void             (*SetDataBits)( uint32_t index, uint32_t databits );
    void             (*SetStopBits)( uint32_t index, uint32_t stopbits );
    void             (*SetParity)( uint32_t index, uint32_t parity );
    void             (*SetFlowControl)( uint32_t index, uint32_t control );
    FAPI_SYS_HandleT (*Open)( FAPI_UART_OpenParamsT* openParamsPtr, int32_t* errorCodePtr );
    int32_t          (*Close)( FAPI_SYS_HandleT handle );
    int32_t          (*WriteByte)( FAPI_SYS_HandleT handle, uint8_t byte );
    int32_t          (*ReadByte)( FAPI_SYS_HandleT handle );
    int32_t          (*CheckTxFifo)( FAPI_SYS_HandleT handle );
    int32_t          (*CheckRxFifo)( FAPI_SYS_HandleT handle );
    void             (*LockMutex)( void );
    void             (*UnlockMutex)( void );
} FAPEX_UART_FuncStrT;

#endif /* _FAPEX_UART_FUNC_H */
