/*!
*************************************************************************
**
** \file    fapex_upi_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_UPI_FUNC_H
#define _FAPEX_UPI_FUNC_H

#include "fapi/drv_upi.h"

typedef struct {
    int32_t          (*Init)( void );
    void             (*Exit)( void );
    FAPI_SYS_HandleT (*Open)( const FAPI_UPI_OpenParamsT* paramsPtr, int32_t* errorCodePtr );
    int32_t          (*Close)( FAPI_SYS_HandleT handle );
    int32_t          (*SetDefaults)( FAPI_SYS_HandleT handle, uint32_t valueSet );
    int32_t          (*SetConfiguration)( FAPI_SYS_HandleT handle, FAPI_UPI_ConfigT* configPtr );
    int32_t          (*GetConfiguration)( FAPI_SYS_HandleT handle, FAPI_UPI_ConfigT* configPtr );
    int32_t          (*SetWaitTimer)( FAPI_SYS_HandleT handle, uint32_t value );
    int32_t          (*GetWaitTimer)( FAPI_SYS_HandleT handle, FAPI_UPI_TimerInfoT* timerInfoPtr );
    int32_t          (*GetBaseAddress)( FAPI_SYS_HandleT handle, uint32_t* addressPtr );
    int32_t          (*Lock)( void );
    void             (*Unlock)( void );
} FAPEX_UPI_FuncStrT;

#endif /* _FAPEX_UPI_FUNC_H */
