/*!
*************************************************************************
**
** \file    fapex_vienc_func.h
**
** \brief   function pointer definiton header file 
**
** \attention  This program is provided as is. You can redistribute it and/or
** modify it. Fujitsu Semiconductor Limited accepts no responsibility or
** liability for any errors or omissions.
**
** Copyright (C) 2009-2010 Fujitsu Semiconductor Limited, All Rights Reserved.
**
*************************************************************************
*/
#ifndef _FAPEX_VIENC_FUNC_H
#define _FAPEX_VIENC_FUNC_H

#include "fapi/drv_vienc.h"

typedef struct {
    int32_t          (*Init)(void);
    void             (*Exit)(void);
    int32_t          (*InitClocks)(FAPI_VIENC_InitClocksEnumT initClkSys);
    FAPI_SYS_HandleT (*Open)(const FAPI_VIENC_OpenParamsT* paramsPtr,
                                                      int32_t* errorCodePtr);
    int32_t          (*Close)(FAPI_SYS_HandleT handle);
    int32_t          (*Start)(FAPI_SYS_HandleT handle);
    int32_t          (*Stop)(FAPI_SYS_HandleT handle);
    FAPI_VIENC_InterlaceProgressiveEnumT 
                     (*GetSystemType)(FAPI_SYS_HandleT handle);
    int32_t          (*EnableDisableWss)(FAPI_SYS_HandleT handle,
                                         FAPI_VIENC_ParameterModeEnumT mode);
    int32_t          (*SetWssData)(FAPI_SYS_HandleT handle, 
                                                           uint32_t wssData);
    int32_t          (*GetWssData)(FAPI_SYS_HandleT handle, 
                                                          uint32_t* wssData);
    int32_t          (*SetColourComponent)(FAPI_SYS_HandleT handle, 
                                  FAPI_VIENC_ComponentEnumT colourComponent);
    int32_t          (*GetColourComponent)(FAPI_SYS_HandleT handle,
                                 FAPI_VIENC_ComponentEnumT* colourComponent);
    int32_t          (*SetDacAssignment)(FAPI_SYS_HandleT handle,
                                 FAPI_VIENC_DacAssignmentEnumT dacAssignment);
//    int32_t          (*ChangeColourComponent)(FAPI_SYS_HandleT handle,
//                                         FAPI_VIENC_ColourSelectorEnumT col,
//                                                            uint32_t offset);
} FAPEX_VIENC_FuncStrT;

#endif /* _FAPEX_VIENC_FUNC_H */
