@echo off
rem ############################################################################
rem ############################################################################
rem ##
rem ## EraseFlash.bat -- Windows command script to erase Flash memory
rem ##
rem ## (C) Copyright 2008-2009 by Fujitsu Microelectronics Limited
rem ##
rem ## This batch file erase the information field of Flash memory.
rem ##
rem ## Usage: EraseFlash
rem ##
rem ############################################################################
rem ############################################################################

setlocal

rem ############################################################################
rem ##
rem ## user environment parameters
rem ##
rem ############################################################################

set TOP_DIR=../..

rem ////////////////////////////////////////////////////////////////////////////
rem //
rem // configuration file
rem //
rem ////////////////////////////////////////////////////////////////////////////

set CONFIG_FILE=%TOP_DIR%/Config.mak


rem ////////////////////////////////////////////////////////////////////////////
rem //
rem // USB port parameter
rem //
rem ////////////////////////////////////////////////////////////////////////////

set USB_PORT=-port=USB0:DEBUGPORT_JTAGPORT:SYSFREQ=324000000:STARTBAUD=38400:BAUDRATE=3000000:RAMBASE=0x02004000


rem ############################################################################
rem ##
rem ## common parameters
rem ##
rem ############################################################################

rem ////////////////////////////////////////////////////////////////////////////
rem //
rem // parameter files
rem //
rem ////////////////////////////////////////////////////////////////////////////

set RVS_FILE=%TOP_DIR%/env/execute/ddr_init.rvs
set WRITER_FILE=%TOP_DIR%/env/bin/M-arm11-realview/flasher.axf


rem ////////////////////////////////////////////////////////////////////////////
rem //
rem // execution program directory
rem //
rem ////////////////////////////////////////////////////////////////////////////

set EXE_DIR=%TOP_DIR%/env/bin/M-win32

set PATH_SAVE=%PATH%
set PATH=%EXE_DIR%;%PATH%


rem ////////////////////////////////////////////////////////////////////////////
rem //
rem // flash parameters
rem //
rem ////////////////////////////////////////////////////////////////////////////

for /f "tokens=1,3" %%a in (%CONFIG_FILE%) do (
   if %%a == FLASHTYPE          set FLASHTYPE=%%b
   if %%a == FLASHBASE          set FLASHBASE=%%b
   if %%a == FLASHER_INFO_BASE  set FLASHER_INFO_BASE=%%b
)


rem ############################################################################
rem ##
rem ## erase flash information field
rem ##
rem ############################################################################

rem ////////////////////////////////////////////////////////////////////////////
rem //
rem // setup burn flash parameters
rem //
rem ////////////////////////////////////////////////////////////////////////////

set USB_DLL=%EXE_DIR%/usbdbgport.dll

set FLASHER_FLAGS=-verbose -flash -flashtype=%FLASHTYPE% -flashbase=%FLASHBASE% -flashoffset=0x0 -flashinfo=%FLASHER_INFO_BASE%
set ERASE_PARAMS=-dll=%USB_DLL% %USB_PORT% -elf=%WRITER_FILE% -wait=polling -rblmsg


rem ////////////////////////////////////////////////////////////////////////////
rem //
rem // erase flash information field
rem //
rem ////////////////////////////////////////////////////////////////////////////

execute.exe %FLASHER_FLAGS% %ERASE_PARAMS% -reg=%RVS_FILE% -flasherase

endlocal

